#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <cstdint>
#include <unistd.h>
#include "dbus_auth.hpp"

static size_t write_string(char* buf, size_t pos, const char* str) {
  const size_t len = strlen(str);
  memcpy(&buf[pos], str, len);
  return pos + len;
}

static void sendbuf(const int fd, char* buf, size_t pos, size_t bufsize)  {
  const ssize_t n = write(fd, buf, pos);
  printf("wrote %ld bytes\n", n);
  memset(&buf[0], 0, bufsize);
  const ssize_t r = read(fd, buf, bufsize);
  printf("%ld: %s\n", r, buf);
  printf("%x %x\n", buf[r-2], buf[r-1]);
}

void dbus_sendauth(const uid_t uid, const int fd) {
  char buf[1024];
  size_t pos = 0;

  buf[pos++] = '\0';

  pos = write_string(buf, pos, "AUTH EXTERNAL ");

  char uidstr[16];
  snprintf(uidstr, sizeof(uidstr), "%d", uid);
  size_t n = strlen(uidstr);
  for (size_t i = 0; i < n; i++) {
    char tmp[4];
    snprintf(tmp, sizeof(tmp), "%.2x", (int)uidstr[i]);
    pos = write_string(buf, pos, tmp);
  }
  pos = write_string(buf, pos, "\r\n");

  sendbuf(fd, buf, pos, sizeof(buf));

  pos = write_string(buf, 0, "NEGOTIATE_UNIX_FD\r\n");
  sendbuf(fd, buf, pos, sizeof(buf));

  pos = write_string(buf, 0, "BEGIN\r\n");
  write(fd, buf, pos);
}
